# coding: utf-8

"""
    Cloudsmith API

    The API to the Cloudsmith Service

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class EntitlementsApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def entitlements_create(self, owner, repo, **kwargs):
        """
        Create a specific entitlement in a repository.
        Create a specific entitlement in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_create(owner, repo, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param bool show_tokens: Show entitlement token strings in results
        :param EntitlementsCreate data:
        :return: RepositoryToken
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.entitlements_create_with_http_info(owner, repo, **kwargs)
        else:
            (data) = self.entitlements_create_with_http_info(owner, repo, **kwargs)
            return data

    def entitlements_create_with_http_info(self, owner, repo, **kwargs):
        """
        Create a specific entitlement in a repository.
        Create a specific entitlement in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_create_with_http_info(owner, repo, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param bool show_tokens: Show entitlement token strings in results
        :param EntitlementsCreate data:
        :return: RepositoryToken
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'show_tokens', 'data']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method entitlements_create" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if ('owner' not in params) or (params['owner'] is None):
            raise ValueError("Missing the required parameter `owner` when calling `entitlements_create`")
        # verify the required parameter 'repo' is set
        if ('repo' not in params) or (params['repo'] is None):
            raise ValueError("Missing the required parameter `repo` when calling `entitlements_create`")


        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']
        if 'repo' in params:
            path_params['repo'] = params['repo']

        query_params = []
        if 'show_tokens' in params:
            query_params.append(('show_tokens', params['show_tokens']))

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['apikey']

        return self.api_client.call_api('/entitlements/{owner}/{repo}/', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='RepositoryToken',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def entitlements_delete(self, owner, repo, identifier, **kwargs):
        """
        Delete a specific entitlement in a repository.
        Delete a specific entitlement in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_delete(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.entitlements_delete_with_http_info(owner, repo, identifier, **kwargs)
        else:
            (data) = self.entitlements_delete_with_http_info(owner, repo, identifier, **kwargs)
            return data

    def entitlements_delete_with_http_info(self, owner, repo, identifier, **kwargs):
        """
        Delete a specific entitlement in a repository.
        Delete a specific entitlement in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_delete_with_http_info(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'identifier']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method entitlements_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if ('owner' not in params) or (params['owner'] is None):
            raise ValueError("Missing the required parameter `owner` when calling `entitlements_delete`")
        # verify the required parameter 'repo' is set
        if ('repo' not in params) or (params['repo'] is None):
            raise ValueError("Missing the required parameter `repo` when calling `entitlements_delete`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `entitlements_delete`")


        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']
        if 'repo' in params:
            path_params['repo'] = params['repo']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['apikey']

        return self.api_client.call_api('/entitlements/{owner}/{repo}/{identifier}/', 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def entitlements_disable(self, owner, repo, identifier, **kwargs):
        """
        Disable an entitlement token in a repository.
        Disable an entitlement token in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_disable(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.entitlements_disable_with_http_info(owner, repo, identifier, **kwargs)
        else:
            (data) = self.entitlements_disable_with_http_info(owner, repo, identifier, **kwargs)
            return data

    def entitlements_disable_with_http_info(self, owner, repo, identifier, **kwargs):
        """
        Disable an entitlement token in a repository.
        Disable an entitlement token in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_disable_with_http_info(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'identifier']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method entitlements_disable" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if ('owner' not in params) or (params['owner'] is None):
            raise ValueError("Missing the required parameter `owner` when calling `entitlements_disable`")
        # verify the required parameter 'repo' is set
        if ('repo' not in params) or (params['repo'] is None):
            raise ValueError("Missing the required parameter `repo` when calling `entitlements_disable`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `entitlements_disable`")


        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']
        if 'repo' in params:
            path_params['repo'] = params['repo']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['apikey']

        return self.api_client.call_api('/entitlements/{owner}/{repo}/{identifier}/disable/', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def entitlements_enable(self, owner, repo, identifier, **kwargs):
        """
        Enable an entitlement token in a repository.
        Enable an entitlement token in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_enable(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.entitlements_enable_with_http_info(owner, repo, identifier, **kwargs)
        else:
            (data) = self.entitlements_enable_with_http_info(owner, repo, identifier, **kwargs)
            return data

    def entitlements_enable_with_http_info(self, owner, repo, identifier, **kwargs):
        """
        Enable an entitlement token in a repository.
        Enable an entitlement token in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_enable_with_http_info(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'identifier']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method entitlements_enable" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if ('owner' not in params) or (params['owner'] is None):
            raise ValueError("Missing the required parameter `owner` when calling `entitlements_enable`")
        # verify the required parameter 'repo' is set
        if ('repo' not in params) or (params['repo'] is None):
            raise ValueError("Missing the required parameter `repo` when calling `entitlements_enable`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `entitlements_enable`")


        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']
        if 'repo' in params:
            path_params['repo'] = params['repo']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['apikey']

        return self.api_client.call_api('/entitlements/{owner}/{repo}/{identifier}/enable/', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def entitlements_list(self, owner, repo, **kwargs):
        """
        Get a list of all entitlements in a repository.
        Get a list of all entitlements in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_list(owner, repo, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param int page: A page number within the paginated result set.
        :param int page_size: Number of results to return per page.
        :param bool show_tokens: Show entitlement token strings in results
        :return: list[RepositoryToken]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.entitlements_list_with_http_info(owner, repo, **kwargs)
        else:
            (data) = self.entitlements_list_with_http_info(owner, repo, **kwargs)
            return data

    def entitlements_list_with_http_info(self, owner, repo, **kwargs):
        """
        Get a list of all entitlements in a repository.
        Get a list of all entitlements in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_list_with_http_info(owner, repo, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param int page: A page number within the paginated result set.
        :param int page_size: Number of results to return per page.
        :param bool show_tokens: Show entitlement token strings in results
        :return: list[RepositoryToken]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'page', 'page_size', 'show_tokens']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method entitlements_list" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if ('owner' not in params) or (params['owner'] is None):
            raise ValueError("Missing the required parameter `owner` when calling `entitlements_list`")
        # verify the required parameter 'repo' is set
        if ('repo' not in params) or (params['repo'] is None):
            raise ValueError("Missing the required parameter `repo` when calling `entitlements_list`")


        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']
        if 'repo' in params:
            path_params['repo'] = params['repo']

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))
        if 'page_size' in params:
            query_params.append(('page_size', params['page_size']))
        if 'show_tokens' in params:
            query_params.append(('show_tokens', params['show_tokens']))

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['apikey']

        return self.api_client.call_api('/entitlements/{owner}/{repo}/', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='list[RepositoryToken]',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def entitlements_partial_update(self, owner, repo, identifier, **kwargs):
        """
        Update a specific entitlement in a repository.
        Update a specific entitlement in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_partial_update(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :param bool show_tokens: Show entitlement token strings in results
        :param EntitlementsPartialUpdate data:
        :return: RepositoryToken
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.entitlements_partial_update_with_http_info(owner, repo, identifier, **kwargs)
        else:
            (data) = self.entitlements_partial_update_with_http_info(owner, repo, identifier, **kwargs)
            return data

    def entitlements_partial_update_with_http_info(self, owner, repo, identifier, **kwargs):
        """
        Update a specific entitlement in a repository.
        Update a specific entitlement in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_partial_update_with_http_info(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :param bool show_tokens: Show entitlement token strings in results
        :param EntitlementsPartialUpdate data:
        :return: RepositoryToken
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'identifier', 'show_tokens', 'data']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method entitlements_partial_update" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if ('owner' not in params) or (params['owner'] is None):
            raise ValueError("Missing the required parameter `owner` when calling `entitlements_partial_update`")
        # verify the required parameter 'repo' is set
        if ('repo' not in params) or (params['repo'] is None):
            raise ValueError("Missing the required parameter `repo` when calling `entitlements_partial_update`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `entitlements_partial_update`")


        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']
        if 'repo' in params:
            path_params['repo'] = params['repo']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = []
        if 'show_tokens' in params:
            query_params.append(('show_tokens', params['show_tokens']))

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['apikey']

        return self.api_client.call_api('/entitlements/{owner}/{repo}/{identifier}/', 'PATCH',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='RepositoryToken',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def entitlements_read(self, owner, repo, identifier, **kwargs):
        """
        Get a specific entitlement in a repository.
        Get a specific entitlement in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_read(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :param bool show_tokens: Show entitlement token strings in results
        :return: RepositoryToken
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.entitlements_read_with_http_info(owner, repo, identifier, **kwargs)
        else:
            (data) = self.entitlements_read_with_http_info(owner, repo, identifier, **kwargs)
            return data

    def entitlements_read_with_http_info(self, owner, repo, identifier, **kwargs):
        """
        Get a specific entitlement in a repository.
        Get a specific entitlement in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_read_with_http_info(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :param bool show_tokens: Show entitlement token strings in results
        :return: RepositoryToken
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'identifier', 'show_tokens']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method entitlements_read" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if ('owner' not in params) or (params['owner'] is None):
            raise ValueError("Missing the required parameter `owner` when calling `entitlements_read`")
        # verify the required parameter 'repo' is set
        if ('repo' not in params) or (params['repo'] is None):
            raise ValueError("Missing the required parameter `repo` when calling `entitlements_read`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `entitlements_read`")


        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']
        if 'repo' in params:
            path_params['repo'] = params['repo']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = []
        if 'show_tokens' in params:
            query_params.append(('show_tokens', params['show_tokens']))

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['apikey']

        return self.api_client.call_api('/entitlements/{owner}/{repo}/{identifier}/', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='RepositoryToken',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def entitlements_refresh(self, owner, repo, identifier, **kwargs):
        """
        Refresh an entitlement token in a repository.
        Refresh an entitlement token in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_refresh(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :param bool show_tokens: Show entitlement token strings in results
        :param EntitlementsRefresh data:
        :return: RepositoryTokenRefresh
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.entitlements_refresh_with_http_info(owner, repo, identifier, **kwargs)
        else:
            (data) = self.entitlements_refresh_with_http_info(owner, repo, identifier, **kwargs)
            return data

    def entitlements_refresh_with_http_info(self, owner, repo, identifier, **kwargs):
        """
        Refresh an entitlement token in a repository.
        Refresh an entitlement token in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_refresh_with_http_info(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :param bool show_tokens: Show entitlement token strings in results
        :param EntitlementsRefresh data:
        :return: RepositoryTokenRefresh
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'identifier', 'show_tokens', 'data']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method entitlements_refresh" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if ('owner' not in params) or (params['owner'] is None):
            raise ValueError("Missing the required parameter `owner` when calling `entitlements_refresh`")
        # verify the required parameter 'repo' is set
        if ('repo' not in params) or (params['repo'] is None):
            raise ValueError("Missing the required parameter `repo` when calling `entitlements_refresh`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `entitlements_refresh`")


        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']
        if 'repo' in params:
            path_params['repo'] = params['repo']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = []
        if 'show_tokens' in params:
            query_params.append(('show_tokens', params['show_tokens']))

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['apikey']

        return self.api_client.call_api('/entitlements/{owner}/{repo}/{identifier}/refresh/', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='RepositoryTokenRefresh',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def entitlements_reset(self, owner, repo, identifier, **kwargs):
        """
        Reset the statistics for an entitlement token in a repository.
        Reset the statistics for an entitlement token in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_reset(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.entitlements_reset_with_http_info(owner, repo, identifier, **kwargs)
        else:
            (data) = self.entitlements_reset_with_http_info(owner, repo, identifier, **kwargs)
            return data

    def entitlements_reset_with_http_info(self, owner, repo, identifier, **kwargs):
        """
        Reset the statistics for an entitlement token in a repository.
        Reset the statistics for an entitlement token in a repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_reset_with_http_info(owner, repo, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param str identifier:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'identifier']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method entitlements_reset" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if ('owner' not in params) or (params['owner'] is None):
            raise ValueError("Missing the required parameter `owner` when calling `entitlements_reset`")
        # verify the required parameter 'repo' is set
        if ('repo' not in params) or (params['repo'] is None):
            raise ValueError("Missing the required parameter `repo` when calling `entitlements_reset`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `entitlements_reset`")


        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']
        if 'repo' in params:
            path_params['repo'] = params['repo']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['apikey']

        return self.api_client.call_api('/entitlements/{owner}/{repo}/{identifier}/reset/', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def entitlements_sync(self, owner, repo, **kwargs):
        """
        Synchronise tokens from a source repository.
        Synchronise tokens from a source repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_sync(owner, repo, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param bool show_tokens: Show entitlement token strings in results
        :param EntitlementsSync data:
        :return: RepositoryTokenSync
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.entitlements_sync_with_http_info(owner, repo, **kwargs)
        else:
            (data) = self.entitlements_sync_with_http_info(owner, repo, **kwargs)
            return data

    def entitlements_sync_with_http_info(self, owner, repo, **kwargs):
        """
        Synchronise tokens from a source repository.
        Synchronise tokens from a source repository.
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.entitlements_sync_with_http_info(owner, repo, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str owner:  (required)
        :param str repo:  (required)
        :param bool show_tokens: Show entitlement token strings in results
        :param EntitlementsSync data:
        :return: RepositoryTokenSync
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['owner', 'repo', 'show_tokens', 'data']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method entitlements_sync" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'owner' is set
        if ('owner' not in params) or (params['owner'] is None):
            raise ValueError("Missing the required parameter `owner` when calling `entitlements_sync`")
        # verify the required parameter 'repo' is set
        if ('repo' not in params) or (params['repo'] is None):
            raise ValueError("Missing the required parameter `repo` when calling `entitlements_sync`")


        collection_formats = {}

        path_params = {}
        if 'owner' in params:
            path_params['owner'] = params['owner']
        if 'repo' in params:
            path_params['repo'] = params['repo']

        query_params = []
        if 'show_tokens' in params:
            query_params.append(('show_tokens', params['show_tokens']))

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['apikey']

        return self.api_client.call_api('/entitlements/{owner}/{repo}/sync/', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='RepositoryTokenSync',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
