# coding: utf-8

"""
    Cloudsmith API

    The API to the Cloudsmith Service

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PackagesUploadVagrant(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'package_file': 'str',
        'provider': 'str',
        'republish': 'bool',
        'security_scan_status': 'str',
        'tags': 'str',
        'version': 'str'
    }

    attribute_map = {
        'name': 'name',
        'package_file': 'package_file',
        'provider': 'provider',
        'republish': 'republish',
        'security_scan_status': 'security_scan_status',
        'tags': 'tags',
        'version': 'version'
    }

    def __init__(self, name=None, package_file=None, provider=None, republish=None, security_scan_status=None, tags=None, version=None):
        """
        PackagesUploadVagrant - a model defined in Swagger
        """

        self._name = None
        self._package_file = None
        self._provider = None
        self._republish = None
        self._security_scan_status = None
        self._tags = None
        self._version = None

        self.name = name
        self.package_file = package_file
        self.provider = provider
        if republish is not None:
          self.republish = republish
        if security_scan_status is not None:
          self.security_scan_status = security_scan_status
        if tags is not None:
          self.tags = tags
        self.version = version

    @property
    def name(self):
        """
        Gets the name of this PackagesUploadVagrant.
        The name of this package.

        :return: The name of this PackagesUploadVagrant.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this PackagesUploadVagrant.
        The name of this package.

        :param name: The name of this PackagesUploadVagrant.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def package_file(self):
        """
        Gets the package_file of this PackagesUploadVagrant.
        The primary file for the package.

        :return: The package_file of this PackagesUploadVagrant.
        :rtype: str
        """
        return self._package_file

    @package_file.setter
    def package_file(self, package_file):
        """
        Sets the package_file of this PackagesUploadVagrant.
        The primary file for the package.

        :param package_file: The package_file of this PackagesUploadVagrant.
        :type: str
        """
        if package_file is None:
            raise ValueError("Invalid value for `package_file`, must not be `None`")

        self._package_file = package_file

    @property
    def provider(self):
        """
        Gets the provider of this PackagesUploadVagrant.
        The virtual machine provider for the box.

        :return: The provider of this PackagesUploadVagrant.
        :rtype: str
        """
        return self._provider

    @provider.setter
    def provider(self, provider):
        """
        Sets the provider of this PackagesUploadVagrant.
        The virtual machine provider for the box.

        :param provider: The provider of this PackagesUploadVagrant.
        :type: str
        """
        if provider is None:
            raise ValueError("Invalid value for `provider`, must not be `None`")

        self._provider = provider

    @property
    def republish(self):
        """
        Gets the republish of this PackagesUploadVagrant.
        If true, the uploaded package will overwrite any others with the same attributes (e.g. same version); otherwise, it will be flagged as a duplicate.

        :return: The republish of this PackagesUploadVagrant.
        :rtype: bool
        """
        return self._republish

    @republish.setter
    def republish(self, republish):
        """
        Sets the republish of this PackagesUploadVagrant.
        If true, the uploaded package will overwrite any others with the same attributes (e.g. same version); otherwise, it will be flagged as a duplicate.

        :param republish: The republish of this PackagesUploadVagrant.
        :type: bool
        """

        self._republish = republish

    @property
    def security_scan_status(self):
        """
        Gets the security_scan_status of this PackagesUploadVagrant.
        None

        :return: The security_scan_status of this PackagesUploadVagrant.
        :rtype: str
        """
        return self._security_scan_status

    @security_scan_status.setter
    def security_scan_status(self, security_scan_status):
        """
        Sets the security_scan_status of this PackagesUploadVagrant.
        None

        :param security_scan_status: The security_scan_status of this PackagesUploadVagrant.
        :type: str
        """

        self._security_scan_status = security_scan_status

    @property
    def tags(self):
        """
        Gets the tags of this PackagesUploadVagrant.
        A comma-separated values list of tags to add to the package.

        :return: The tags of this PackagesUploadVagrant.
        :rtype: str
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """
        Sets the tags of this PackagesUploadVagrant.
        A comma-separated values list of tags to add to the package.

        :param tags: The tags of this PackagesUploadVagrant.
        :type: str
        """

        self._tags = tags

    @property
    def version(self):
        """
        Gets the version of this PackagesUploadVagrant.
        The raw version for this package.

        :return: The version of this PackagesUploadVagrant.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this PackagesUploadVagrant.
        The raw version for this package.

        :param version: The version of this PackagesUploadVagrant.
        :type: str
        """
        if version is None:
            raise ValueError("Invalid value for `version`, must not be `None`")

        self._version = version

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PackagesUploadVagrant):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
