# coding: utf-8

"""
    Cloudsmith API

    The API to the Cloudsmith Service

    OpenAPI spec version: v1
    Contact: support@cloudsmith.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PackagesValidateuploadDeb(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'changes_file': 'str',
        'distribution': 'str',
        'package_file': 'str',
        'republish': 'bool',
        'security_scan_status': 'str',
        'sources_file': 'str',
        'tags': 'str'
    }

    attribute_map = {
        'changes_file': 'changes_file',
        'distribution': 'distribution',
        'package_file': 'package_file',
        'republish': 'republish',
        'security_scan_status': 'security_scan_status',
        'sources_file': 'sources_file',
        'tags': 'tags'
    }

    def __init__(self, changes_file=None, distribution=None, package_file=None, republish=None, security_scan_status=None, sources_file=None, tags=None):
        """
        PackagesValidateuploadDeb - a model defined in Swagger
        """

        self._changes_file = None
        self._distribution = None
        self._package_file = None
        self._republish = None
        self._security_scan_status = None
        self._sources_file = None
        self._tags = None

        if changes_file is not None:
          self.changes_file = changes_file
        self.distribution = distribution
        self.package_file = package_file
        if republish is not None:
          self.republish = republish
        if security_scan_status is not None:
          self.security_scan_status = security_scan_status
        if sources_file is not None:
          self.sources_file = sources_file
        if tags is not None:
          self.tags = tags

    @property
    def changes_file(self):
        """
        Gets the changes_file of this PackagesValidateuploadDeb.
        The changes archive containing the changes made to the source and debian packaging files

        :return: The changes_file of this PackagesValidateuploadDeb.
        :rtype: str
        """
        return self._changes_file

    @changes_file.setter
    def changes_file(self, changes_file):
        """
        Sets the changes_file of this PackagesValidateuploadDeb.
        The changes archive containing the changes made to the source and debian packaging files

        :param changes_file: The changes_file of this PackagesValidateuploadDeb.
        :type: str
        """

        self._changes_file = changes_file

    @property
    def distribution(self):
        """
        Gets the distribution of this PackagesValidateuploadDeb.
        The distribution to store the package for.

        :return: The distribution of this PackagesValidateuploadDeb.
        :rtype: str
        """
        return self._distribution

    @distribution.setter
    def distribution(self, distribution):
        """
        Sets the distribution of this PackagesValidateuploadDeb.
        The distribution to store the package for.

        :param distribution: The distribution of this PackagesValidateuploadDeb.
        :type: str
        """
        if distribution is None:
            raise ValueError("Invalid value for `distribution`, must not be `None`")

        self._distribution = distribution

    @property
    def package_file(self):
        """
        Gets the package_file of this PackagesValidateuploadDeb.
        The primary file for the package.

        :return: The package_file of this PackagesValidateuploadDeb.
        :rtype: str
        """
        return self._package_file

    @package_file.setter
    def package_file(self, package_file):
        """
        Sets the package_file of this PackagesValidateuploadDeb.
        The primary file for the package.

        :param package_file: The package_file of this PackagesValidateuploadDeb.
        :type: str
        """
        if package_file is None:
            raise ValueError("Invalid value for `package_file`, must not be `None`")

        self._package_file = package_file

    @property
    def republish(self):
        """
        Gets the republish of this PackagesValidateuploadDeb.
        If true, the uploaded package will overwrite any others with the same attributes (e.g. same version); otherwise, it will be flagged as a duplicate.

        :return: The republish of this PackagesValidateuploadDeb.
        :rtype: bool
        """
        return self._republish

    @republish.setter
    def republish(self, republish):
        """
        Sets the republish of this PackagesValidateuploadDeb.
        If true, the uploaded package will overwrite any others with the same attributes (e.g. same version); otherwise, it will be flagged as a duplicate.

        :param republish: The republish of this PackagesValidateuploadDeb.
        :type: bool
        """

        self._republish = republish

    @property
    def security_scan_status(self):
        """
        Gets the security_scan_status of this PackagesValidateuploadDeb.
        None

        :return: The security_scan_status of this PackagesValidateuploadDeb.
        :rtype: str
        """
        return self._security_scan_status

    @security_scan_status.setter
    def security_scan_status(self, security_scan_status):
        """
        Sets the security_scan_status of this PackagesValidateuploadDeb.
        None

        :param security_scan_status: The security_scan_status of this PackagesValidateuploadDeb.
        :type: str
        """

        self._security_scan_status = security_scan_status

    @property
    def sources_file(self):
        """
        Gets the sources_file of this PackagesValidateuploadDeb.
        The sources archive containing the source code for the binary

        :return: The sources_file of this PackagesValidateuploadDeb.
        :rtype: str
        """
        return self._sources_file

    @sources_file.setter
    def sources_file(self, sources_file):
        """
        Sets the sources_file of this PackagesValidateuploadDeb.
        The sources archive containing the source code for the binary

        :param sources_file: The sources_file of this PackagesValidateuploadDeb.
        :type: str
        """

        self._sources_file = sources_file

    @property
    def tags(self):
        """
        Gets the tags of this PackagesValidateuploadDeb.
        A comma-separated values list of tags to add to the package.

        :return: The tags of this PackagesValidateuploadDeb.
        :rtype: str
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """
        Sets the tags of this PackagesValidateuploadDeb.
        A comma-separated values list of tags to add to the package.

        :param tags: The tags of this PackagesValidateuploadDeb.
        :type: str
        """

        self._tags = tags

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PackagesValidateuploadDeb):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
